// character.h
//  Characters!!!

#define ADD_CHARACTER(char) \
	char* The##char = new char; \
	uint32_t char##ID = Character::RegisterCharacter(The##char)

enum EDirection
{
	D_Down, D_Up, D_Left, D_Right,
	D_DownLeft, D_DownRight, D_UpLeft, D_UpRight
};

enum EState
{
	S_Standing, S_Walking, S_Jumping
};
	
class Character
{
	public: // Public static variables
		static std::vector<Character*> chars;
		
	public: // Public static functions
		static uint32_t RegisterCharacter(Character* c);
		static void StaticInitGraphics();
		static void StaticDestroy();
		static Character* GetByName(const char* name);
		
	public: // Public variables
		bool playable;
		const char* name;
		uint32_t id;
		
		EDirection dir;
		EState state;
		double progress;
		double animphase;
		double timedialation;
		
	public: // Public functions
		Character();
		Character(EUnlockable): playable(false)
		{ }
		virtual ~Character()
		{ }
		
		virtual bool InitGraphics()
		{ return true; }
		
		virtual void DrawPortrait(BITMAP* dest, int x, int y, int w, int h) = 0;
		
		virtual void DrawSelf(BITMAP* dest, int x, int y, int w, int h) = 0;
		
		void StandardStates(BITMAP* dest, int x, int y, int w, int h, BITMAP* frame);
		
		virtual EStatus Tick(double dtime);
		virtual void Animate(EState animation, double timetoarrive);
		virtual void Face(EDirection newdir);
};

// The end
