// gamestate.cpp
//  Base class for Game States

#include "tinparty.h"

using namespace std;

GameState::~GameState()
{
}

SubState::SubState(): done(false)
{ }

SubStateText::SubStateText(const char* text, int x, int y, int w, int h, ETextboxMode mode): text(text), pos(0), x(x), y(y), w(w), h(h), tnl(0), lastword(0), thisline(0), mode(mode)
{
	len = strlen(text);
	buffer = new char [len + 1];
}

SubStateText::~SubStateText()
{
	delete [] buffer;
}

static uint32_t en_text_width(FONT* font, const char* msg)
{
	uint32_t count = 0;
	char temp[2] = " ";
	for(int i = 0; msg[i] != '\0'; i++)
	{
		if(msg[i] != '$')
		{
			temp[0] = msg[i];
			count += text_length(font, temp);
		}
		else if(msg[i + 1] != '$')
			i += 6;
		else
		{
			temp[0] = msg[i + 1];
			count += text_length(font, temp);
		}
	}
	return count;
}

EStatus SubStateText::Tick(double dtime)
{
	tnl += dtime * 10;
	if(done) return S_Next;
	while(tnl >= 1)
	{
		tnl -= 1;
		if(text[pos] == '\0')
			done = true;
		else if(text[pos] == ' ')
		{
			lastword = pos;
			buffer[pos] = text[pos];
			pos++;
			buffer[pos] = '\0';
		}
		else if(text[pos] == '$')
		{
			buffer[pos] = text[pos];
			pos++;
			if(text[pos] != '$')
			{
				buffer[pos] = text[pos];
				pos++;
				buffer[pos] = text[pos];
				pos++;
				buffer[pos] = text[pos];
				pos++;
				buffer[pos] = text[pos];
				pos++;
				buffer[pos] = text[pos];
				pos++;
				buffer[pos] = text[pos];
				pos++;
			}
			buffer[pos] = text[pos];
			pos++;
		}
		else
		{
			buffer[pos] = text[pos];
			pos++;
			buffer[pos] = '\0';
		}
		if(en_text_width(font, &buffer[thisline]) > w)
		{
			if(lastword > thisline)
			{
				buffer[lastword] = '\n';
				thisline = lastword + 1;
			}
			else
				cout << "Can't wrap" << endl;
		}
	}
	
	return S_Continue;
}

void SubStateText::Draw(BITMAP* dest)
{
	if(mode == TM_Filled)
	{
		rectfill(dest, x, y, x + w - 1, y + h - 1, makecol(255, 255, 255));
		rect(dest, x, y, x + w - 1, y + h - 1, 0);
		en_renderf(dest, font, x + 3, y + 3, "$aa0000%s", buffer);
	}
	else
		en_renderf(dest, font, x, y, "$aa0000%s", buffer);
}



// The end
