// pawn.h
//  Player pawns

enum EPawnState
{
	PS_None,
	PS_Rolling,			// Need to jump sometime
	PS_RollingInAir,	// Watch for when to stop the block
};

class Pawn
{
	public: // Public variables
		Character* instance;
		uint32_t pnum;
		int location;
		EPawnState state;
		
		int sx, sy;
		int dx, dy;
		int x, y;
		double progress;
		double timedialation;
		
	public: // Public functions
		Pawn(uint32_t pnum): instance(NULL), pnum(pnum), state(PS_None)
		{ }
		virtual ~Pawn() = 0;
		
		virtual void GotoState(EPawnState news)
		{ state = news; }
		
		void Move(int x, int y)
		{ this->x = sx = dx = x; this->y = sy = dy = y; }
		void MoveTo(int x, int y, double timetoarrive);
		
		virtual EStatus Tick(double dtime);
		virtual void Draw(BITMAP* dest, int x, int y, int w, int h);
};

/// Local, human player
class HumanPawn: public Pawn
{
	public: // Public functions
		HumanPawn(uint32_t pnum): Pawn(pnum)
		{ }
		virtual void GotoState(EPawnState news);
		virtual EStatus Tick(double dtime);
};

/// Computer player
class ComputerPawn: public Pawn
{
	public: // Public variables
		double timetoreact;
		double progress;
	public: // Public functions
		ComputerPawn(uint32_t pnum): Pawn(pnum)
		{ }
		virtual void GotoState(EPawnState news);
		virtual EStatus Tick(double dtime);
};

// The end
