// plat.h
//  Platform compatibility


#ifdef __linux__
#	include <stdint.h>
#	include <sys/time.h>
#endif

#ifdef __MINGW32__
#	include <stdint.h>
#	include <winalleg.h>
/// Define the [u]?int[0-9]+_t types (int32_t)
typedef unsigned __int8 uint8_t;
typedef unsigned __int16 uint16_t;
typedef unsigned __int32 uint32_t;
typedef unsigned __int64 uint64_t;
#endif

#ifdef _MSC_VER
#	include <winalleg.h>
#	undef min
#	undef max
typedef __int8 int8_t;
typedef unsigned __int8 uint8_t;
typedef __int16 int16_t;
typedef unsigned __int16 uint16_t;
typedef __int32 int32_t;
typedef unsigned __int32 uint32_t;
typedef __int64 int64_t;
typedef unsigned __int64 uint64_t;
#endif

void* GetDiff(void* _then, double& dtime);
void Sleep(uint32_t msecs);

// The end
